/*
 File: subrules_phrase.h
 Date and Time: Fri Jan 30 18:55:25 2015 
*/
#ifndef __subrules_phrase_h__
#define __subrules_phrase_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "lint_balls.h"
#include "eol.h"
#include "c_comments.h"
#include "identifier.h"
#include "c_string.h"
#include "subrule_def.h"
  
extern yacco2::Thread_entry ITH_subrules_phrase;

extern yacco2::State S1_Csubrules_phrase;
namespace NS_subrules_phrase {
yacco2::THR _YACCO2_CALL_TYPE
TH_subrules_phrase(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_subrules_phrase(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[5];
};
class Csubrules_phrase: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rsubrules_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_Rsubrules_phrase_ = 1
   ,R_Rsubrule_defs_ = 570//start_of_rule_list + 2
    ,rhs1_Rsubrule_defs_ = 2
    ,rhs2_Rsubrule_defs_ = 3
   ,R_Rsubrule_def_ = 571//start_of_rule_list + 4
    ,rhs1_Rsubrule_def_ = 4
    ,rhs2_Rsubrule_def_ = 5
    ,rhs3_Rsubrule_def_ = 6
   ,R_Rsubrule_def1_ = 572//start_of_rule_list + 6
    ,rhs1_Rsubrule_def1_ = 7
    ,rhs2_Rsubrule_def1_ = 8
   ,R_Rlint_ = 573//start_of_rule_list + 8
    ,rhs1_Rlint_ = 9
    ,rhs2_Rlint_ = 10
  };
  //no of la sets = 2
  //no of states = 15
  Csubrules_phrase();
  ~Csubrules_phrase();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[11];
  
    public:
    T_subrules_phrase* subrules_phrase_;
    int subrule_no_;
  
 };
struct Rsubrules_phrase;
struct Rsubrule_defs;
struct Rsubrule_def;
struct Rsubrule_def1;
struct Rlint;
struct Rsubrules_phrase:public yacco2::CAbs_lr1_sym {
  Rsubrules_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rsubrule_defs:public yacco2::CAbs_lr1_sym {
  Rsubrule_defs(yacco2::Parser* P);
  public:
};

struct Rsubrule_def:public yacco2::CAbs_lr1_sym {
  Rsubrule_def(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rsubrule_def1:public yacco2::CAbs_lr1_sym {
  Rsubrule_def1(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

} // end of namespace

#endif
